# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section     free

Name:           modello
Version:        1.0
Release:        0.a4.1jpp
Epoch:          0
Summary:        Modello Data Model toolkit
License:        Open Source
Group:          Development/Java
Vendor:         JPackage Project
Distribution:   JPackage
URL:            http://modello.codehaus.org/
Source0:        modello-1.0-alpha-4-src.tar.gz
# svn export svn://svn.modello.codehaus.org/modello/scm/tags/modello-1.0-alpha-4/
Source1:        modello-1.0-buildset.tar.gz
Source2:        modello.script

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildArch:      noarch
BuildRequires:  ant >= 0:1.6
BuildRequires:  jpackage-utils >= 0:1.6
%if %{with_maven}
BuildRequires:  maven-project
BuildRequires:  maven-plugin-api
%endif
BuildRequires:	classworlds >= 0:1.1
BuildRequires:	dtdparser
BuildRequires:	plexus-container-default
BuildRequires:	plexus-utils
BuildRequires:	plexus-velocity
BuildRequires:	velocity

%description
Modello is a Data Model toolkit in use by the 
http://maven.apache.org/maven2.
It all starts with the Data Model. Once a data model is defined, 
the toolkit can be used to generate any of the following at compile 
time.
Java POJOs of the model.
Java POJOs to XML Writer (provided via xpp3 or dom4j).
XML to Java Pojos Reader (provided via xpp3 or dom4j).
XDoc documentation of the data model.
Java model to [Prevayler|http://www.prevayler.org/] Store.
Java model to [JPOX|http://www.jpox.org/] Store.
Java model to [JPOX|http://www.jpox.org/] Mapping.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%if %{with_maven}
%package maven-plugin
Summary:        Maven Plugin for %{name}
Group:          Development/Java

%description maven-plugin
%{summary}.
%endif

%prep
%setup -q -n modello-1.0-alpha-4
gzip -dc %{SOURCE1} | tar xf -
mv modello-1.0-core-build.xml modello-core/build.xml
mv modello-1.0-core-project.xml modello-core/project.xml
mv modello-1.0-maven-plugin-build.xml modello-maven-plugin/build.xml
mv modello-1.0-maven-plugin-project.xml modello-maven-plugin/project.xml
mv modello-1.0-plugin-dom4j-build.xml modello-plugins-sandbox/modello-plugin-dom4j/build.xml
mv modello-1.0-plugin-dom4j-project.xml modello-plugins-sandbox/modello-plugin-dom4j/project.xml
mv modello-1.0-plugin-dtd-build.xml modello-plugins-sandbox/modello-plugin-dtd/build.xml
mv modello-1.0-plugin-dtd-project.xml modello-plugins-sandbox/modello-plugin-dtd/project.xml
mv modello-1.0-plugin-hibernate-old-build.xml modello-plugins-sandbox/modello-plugin-hibernate-old/build.xml
mv modello-1.0-plugin-hibernate-old-project.xml modello-plugins-sandbox/modello-plugin-hibernate-old/project.xml
mv modello-1.0-plugin-hibernate-store-build.xml modello-plugins-sandbox/modello-plugin-hibernate-store/build.xml
mv modello-1.0-plugin-hibernate-store-project.xml modello-plugins-sandbox/modello-plugin-hibernate-store/project.xml
mv modello-1.0-plugin-jdbc-build.xml modello-plugins-sandbox/modello-plugin-jdbc/build.xml
mv modello-1.0-plugin-jdbc-project.xml modello-plugins-sandbox/modello-plugin-jdbc/project.xml
mv modello-1.0-plugin-jpox-build.xml modello-plugins/modello-plugin-jpox/build.xml
mv modello-1.0-plugin-jpox-project.xml modello-plugins/modello-plugin-jpox/project.xml
mv modello-1.0-plugin-ldap-build.xml modello-plugins-sandbox/modello-plugin-ldap/build.xml
mv modello-1.0-plugin-ldap-project.xml modello-plugins-sandbox/modello-plugin-ldap/project.xml
mv modello-1.0-plugin-ojb-build.xml modello-plugins-sandbox/modello-plugin-ojb/build.xml
mv modello-1.0-plugin-ojb-project.xml modello-plugins-sandbox/modello-plugin-ojb/project.xml
mv modello-1.0-plugin-prevayler-build.xml modello-plugins/modello-plugin-prevayler/build.xml
mv modello-1.0-plugin-prevayler-project.xml modello-plugins/modello-plugin-prevayler/project.xml
mv modello-1.0-plugin-stash-build.xml modello-plugins-sandbox/modello-plugin-stash/build.xml
mv modello-1.0-plugin-stash-project.xml modello-plugins-sandbox/modello-plugin-stash/project.xml
mv modello-1.0-plugin-store-build.xml modello-plugins/modello-plugin-store/build.xml
mv modello-1.0-plugin-store-project.xml modello-plugins/modello-plugin-store/project.xml
mv modello-1.0-plugin-velocity-build.xml modello-plugins-sandbox/modello-plugin-velocity/build.xml
mv modello-1.0-plugin-velocity-project.xml modello-plugins-sandbox/modello-plugin-velocity/project.xml
mv modello-1.0-plugin-xdoc-build.xml modello-plugins/modello-plugin-xdoc/build.xml
mv modello-1.0-plugin-xdoc-project.xml modello-plugins/modello-plugin-xdoc/project.xml
mv modello-1.0-plugin-xml-build.xml modello-plugins/modello-plugin-xml/build.xml
mv modello-1.0-plugin-xml-project.xml modello-plugins/modello-plugin-xml/project.xml
mv modello-1.0-plugin-xpp3-build.xml modello-plugins/modello-plugin-xpp3/build.xml
mv modello-1.0-plugin-xpp3-project.xml modello-plugins/modello-plugin-xpp3/project.xml
mv modello-1.0-plugin-xsd-build.xml modello-plugins/modello-plugin-xsd/build.xml
mv modello-1.0-plugin-xsd-project.xml modello-plugins/modello-plugin-xsd/project.xml


%build
pushd modello-core
mkdir -p target/lib
build-jar-repository -s -p target/lib \
plexus/utils \
plexus/container-default
ant jar javadoc
popd

%if %{with_maven}
pushd modello-maven-plugin
mkdir -p target/lib
cp ../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
maven  
ant jar javadoc
popd
%endif

pushd modello-plugins

pushd modello-plugin-store
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib \
velocity \
plexus/velocity \
plexus/utils \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-prevayler
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../modello-plugin-store/target/modello-plugin-store-1.0-alpha-4.jar target/lib
build-jar-repository -s -p target/lib \
velocity \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-xml
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib \
plexus/utils \
plexus/container-default \
classworlds
ant jar javadoc
popd

pushd modello-plugin-xdoc
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../modello-plugin-xml/target/modello-plugin-xml-1.0-alpha-4.jar target/lib
build-jar-repository -s -p target/lib \
plexus/utils \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-xpp3
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../modello-plugin-xml/target/modello-plugin-xml-1.0-alpha-4.jar target/lib
build-jar-repository -s -p target/lib/ \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-xsd
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
plexus/utils \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-jpox
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../modello-plugin-store/target/modello-plugin-store-1.0-alpha-4.jar target/lib
build-jar-repository -s -p target/lib \
velocity \
plexus/utils \
plexus/container-default
ant jar javadoc
popd

popd

pushd modello-plugins-sandbox

pushd modello-plugin-dom4j
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../../modello-plugins/modello-plugin-xml/target/modello-plugin-xml-1.0-alpha-4.jar target/lib
build-jar-repository -s -p target/lib \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-dtd
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib \
dtdparser
ant jar javadoc
popd

pushd modello-plugin-hibernate-old
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib \
plexus/utils \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-hibernate-store
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../../modello-plugins/modello-plugin-store/target/modello-plugin-store-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
velocity \
plexus/velocity \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-jdbc
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../../modello-plugins/modello-plugin-store/target/modello-plugin-store-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
velocity \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-ldap
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-ojb
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
cp ../../modello-plugins/modello-plugin-store/target/modello-plugin-store-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
velocity \
plexus/velocity \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-stash
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
velocity \
plexus/velocity \
plexus/container-default
ant jar javadoc
popd

pushd modello-plugin-velocity
mkdir -p target/lib
cp ../../modello-core/target/modello-core-1.0-alpha-4.jar target/lib/
build-jar-repository -s -p target/lib/ \
velocity \
plexus/velocity \
plexus/container-default
ant jar javadoc
popd

popd

%install
rm -rf $RPM_BUILD_ROOT
# script
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/%{name}
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 \
	modello-core/target/modello-core-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
%if %{with_maven}
install -m 644 \
	modello-maven-plugin/target/modello-maven-plugin-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-maven-plugin-%{version}.jar
%endif
install -m 644 \
	modello-plugins/modello-plugin-jpox/target/modello-plugin-jpox-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-jpox-%{version}.jar
install -m 644 \
	modello-plugins/modello-plugin-prevayler/target/modello-plugin-prevayler-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-prevayler-%{version}.jar
install -m 644 \
	modello-plugins/modello-plugin-store/target/modello-plugin-store-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-store-%{version}.jar
install -m 644 \
	modello-plugins/modello-plugin-xdoc/target/modello-plugin-xdoc-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-xdoc-%{version}.jar
install -m 644 \
	modello-plugins/modello-plugin-xml/target/modello-plugin-xml-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-xml-%{version}.jar
install -m 644 \
	modello-plugins/modello-plugin-xpp3/target/modello-plugin-xpp3-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-xpp3-%{version}.jar
install -m 644 \
	modello-plugins/modello-plugin-xsd/target/modello-plugin-xsd-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-xsd-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-dom4j/target/modello-plugin-dom4j-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-dom4j-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-dtd/target/modello-plugin-dtd-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-dtd-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-hibernate-old/target/modello-plugin-hibernate-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-hibernate-old-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-hibernate-store/target/modello-plugin-hibernate-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-hibernate-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-jdbc/target/modello-plugin-jdbc-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-jdbc-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-ldap/target/modello-plugin-ldap-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-ldap-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-ojb/target/modello-plugin-ojb-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-ojb-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-stash/target/modello-plugin-stash-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-stash-%{version}.jar
install -m 644 \
	modello-plugins-sandbox/modello-plugin-velocity/target/modello-plugin-velocity-1.0-alpha-4-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-velocity-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
pushd modello-core
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core
popd
%if %{with_maven}
pushd modello-maven-plugin
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven-plugin
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven-plugin
popd
%endif
pushd modello-plugins
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugins
for p in jpox prevayler store xdoc xml xpp3 xsd; do
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugins/$p
pushd modello-plugin-$p
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugins/$p
popd
done
popd
pushd modello-plugins-sandbox
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugins-sandbox
for p in dom4j dtd hibernate-old hibernate-store jdbc ldap ojb stash velocity; do
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugins-sandbox/$p
pushd modello-plugin-$p
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugins-sandbox/$p
popd
done
popd
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}
%attr(755,root,root) %{_bindir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_maven}
%files maven-plugin
%defattr(-,root,root,-)
%{_javadir}/%{name}-maven-plugin*.jar
%endif


%changelog
* Mon Nov 07 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.a4.1jpp
- First JPackage build

